Redmine::Plugin.register :restrict_time_entry do
  name 'restrict_time_entry'
  author 'www.redmineplugins.cn'
  description 'A plugin to restrict time entry on weekends and holidays'
  version '1.0.0'
  url 'https://www.redmineplugins.cn'
  author_url 'mailto:support@redmineplugins.cn'

  settings partial: 'settings/restrict_time_entry_settings',
    default: {'holidays' => ''}
end

require_relative './lib/restrict_time_entry/hooks'

TimeEntry.prepend Module.new {
  def validate_working_day
    holidays = Setting.plugin_restrict_time_entry['holidays'].to_s.split(',')
    if spent_on.saturday? || spent_on.sunday? || holidays.include?(spent_on.to_s)
      errors.add(:spent_on, :invalid)
    end
  end

  def validate_time_entry
    super
    validate_working_day
  end
}
